aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
diff options
context:
space:
mode:
authorAdrian Schmutzler <freifunk@adrianschmutzler.de>2020-01-18 02:21:13 +0100
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>2020-01-21 14:24:49 +0100
commit1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b (patch)
treeda02f4bb267128497f1ad7e3c755c8685d8005d1 /target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
parente93626f1f47ec6c1995067c9ed3798ebd468cda3 (diff)
downloadupstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.tar.gz
upstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.tar.bz2
upstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.zip
mvebu: split base-files across subtargets
For the mvebu target in particular, there is a lot of files in base-files that are only relevant for one subtarget. Improve overview and reduce size per subtarget by moving/splitting base-files depending on the subtarget they belong to. While at it, consolidate 01_leds by using the model part of the board name as variable. Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de> Acked-by: Tomasz Maciej Nowak <tomek_n@o2.pl>
Diffstat (limited to 'target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh')
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh98
1 files changed, 98 insertions, 0 deletions
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
new file mode 100644
index 0000000000..6ccfdd0768
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
@@ -0,0 +1,98 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+#
+
+linksys_get_target_firmware() {
+
+ local cur_boot_part mtd_ubi0
+
+ cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
+ if [ -z "${cur_boot_part}" ] ; then
+ mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
+ case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
+ kernel1|rootfs1)
+ cur_boot_part=1
+ ;;
+ kernel2|rootfs2)
+ cur_boot_part=2
+ ;;
+ esac
+ >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
+ "${cur_boot_part}" "${mtd_ubi0}"
+ fi
+
+ case $cur_boot_part in
+ 1)
+ fw_setenv -s - <<-EOF
+ boot_part 2
+ bootcmd "run altnandboot"
+ EOF
+ printf "kernel2"
+ return
+ ;;
+ 2)
+ fw_setenv -s - <<-EOF
+ boot_part 1
+ bootcmd "run nandboot"
+ EOF
+ printf "kernel1"
+ return
+ ;;
+ *)
+ return
+ ;;
+ esac
+}
+
+linksys_get_root_magic() {
+ (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+ local magic_long="$(get_magic_long "$1")"
+
+ mkdir -p /var/lock
+ local part_label="$(linksys_get_target_firmware)"
+ touch /var/lock/fw_printenv.lock
+
+ if [ ! -n "$part_label" ]
+ then
+ echo "cannot find target partition"
+ exit 1
+ fi
+
+ local target_mtd=$(find_mtd_part $part_label)
+
+ [ "$magic_long" = "73797375" ] && {
+ CI_KERNPART="$part_label"
+ if [ "$part_label" = "kernel1" ]
+ then
+ CI_UBIPART="rootfs1"
+ else
+ CI_UBIPART="rootfs2"
+ fi
+
+ nand_upgrade_tar "$1"
+ }
+ [ "$magic_long" = "27051956" -o "$magic_long" = "0000a0e1" ] && {
+ # check firmwares' rootfs types
+ local target_mtd=$(find_mtd_part $part_label)
+ local oldroot="$(linksys_get_root_magic $target_mtd)"
+ local newroot="$(linksys_get_root_magic "$1")"
+
+ if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
+ # we're upgrading from a firmware with UBI to one with UBI
+ then
+ # erase everything to be safe
+ mtd erase $part_label
+ get_image "$1" | mtd -n write - $part_label
+ else
+ get_image "$1" | mtd write - $part_label
+ fi
+ }
+}
+
+platform_copy_config_linksys() {
+ cp -f "$UPGRADE_BACKUP" "/tmp/syscfg/$BACKUP_FILE"
+ sync
+}